    All Packages  Class Hierarchy  This Package  Previous  Next  Index

# Class java.util.Observable

    java.lang.Object
       |
       +----java.util.Observable

public class Observable
extends Object

This class represents an observable object, or "data" in the model-view paradigm. It can be subclassed to represent an object that the application wants to have observed.

An observable object can have one or more observers. After an observable instance changes, an application calling the `Observable`'s `notifyObservers` method causes all of its observers to be notified of the change by a call to their `update` method.

See Also:
  notifyObservers, notifyObservers, Observer, update

##

Observable()
  Construct an Observable with zero Observers

##

addObserver(Observer)
  Adds an observer to the set of observers for this object.
clearChanged()
  Indicates that this object has no longer changed, or that it has already notified all of its observers of its most recent change.
countObservers()
  Returns the number of observers of this object.
deleteObserver(Observer)
  Deletes an observer from the set of observers of this object.
deleteObservers()
  Clears the observer list so that this object no longer has any observers.
hasChanged()
  Tests if this object has changed.
notifyObservers()
  If this object has changed, as indicated by the `hasChanged` method, then notify all of its observers and then call the `clearChanged` method to indicate that this object has no longer changed.
notifyObservers(Object)
  If this object has changed, as indicated by the `hasChanged` method, then notify all of its observers and then call the `clearChanged` method to indicate that this object has no longer changed.
setChanged()
  Indicates that this object has changed.

##

Observable

     public Observable()

  Construct an Observable with zero Observers

##

addObserver

     public synchronized void addObserver(Observer o)

  Adds an observer to the set of observers for this object.

  Parameters:
    o - an observer to be added.

deleteObserver

     public synchronized void deleteObserver(Observer o)

  Deletes an observer from the set of observers of this object.

  Parameters:
    o - the observer to be deleted.

notifyObservers

     public void notifyObservers()

  If this object has changed, as indicated by the `hasChanged` method, then notify all of its observers and then call the `clearChanged` method to indicate that this object has no longer changed.

  Each observer has its `update` method called with two arguments: this observable object and `null`.

  See Also:
    clearChanged, hasChanged, update

notifyObservers

     public void notifyObservers(Object arg)

  If this object has changed, as indicated by the `hasChanged` method, then notify all of its observers and then call the `clearChanged` method to indicate that this object has no longer changed.

  Each observer has its `update` method called with two arguments: this observable object and the `arg` argument.

  Parameters:
    arg - any object.
  See Also:
    clearChanged, hasChanged, update

deleteObservers

     public synchronized void deleteObservers()

  Clears the observer list so that this object no longer has any observers.

setChanged

     protected synchronized void setChanged()

  Indicates that this object has changed.

clearChanged

     protected synchronized void clearChanged()

  Indicates that this object has no longer changed, or that it has already notified all of its observers of its most recent change. This method is called automatically by the `notifyObservers` methods.

  See Also:
    notifyObservers, notifyObservers

hasChanged

     public synchronized boolean hasChanged()

  Tests if this object has changed.

  Returns:
    `true` if the `setChanged` method has been called more recently than the `clearChanged` method on this object; `false` otherwise.
  See Also:
    clearChanged, setChanged

countObservers

     public synchronized int countObservers()

  Returns the number of observers of this object.

  Returns:
    the number of observers of this object.

    All Packages  Class Hierarchy  This Package  Previous  Next  Index

Submit a bug or feature - Version 1.1.8 of Java Platform API Specification
Java is a trademark or registered trademark of Sun Microsystems, Inc. in the US and other countries.
Copyright 1995-1999 Sun Microsystems, Inc. 901 San Antonio Road,
Palo Alto, California, 94303, U.S.A. All Rights Reserved.